	bits 16

%define _SOUND_ASM_
%include "defs.inc"

global DoSound
global SndOff

extern sndFlag
extern sndCount
extern sndPtr
extern sndLvDn
extern sndDead
extern sndCoin
extern sndAppr
extern sndDsAp
extern sndSwch

extern keys

SEGMENT	_TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( DoSound )=------------------------------------------------------------
; -=( Verarbeitet die nchste Frequenz, auf die sndPtr zeigt )=-
; --------------------------------------------------------------------------
DoSound:
	pusha

	cmp byte [sndFlag],0
	jne .Sound 

	call SndOff

	cmp byte [cs:keys+KEY_S],0
	mov byte [cs:keys+KEY_S],0
	je .NoOn
	mov byte [sndFlag],1

.NoOn:	popa
	ret
	

.Sound:	cmp byte [cs:keys+KEY_S],0
	mov byte [cs:keys+KEY_S],0
	je .NoOff
	mov byte [sndFlag],0
	popa
	ret

.NoOff:
	mov si,[sndPtr]
	
.getNote:	
	mov bx,[si]
	or bx,bx
	je .noSound

	mov ax,034DDh
	mov dx,0012h
	cmp dx,bx
	jnb .Bye
	div bx
	mov bx,ax
	in al,061h
	test al,3
	jne .skipAnOr
	or al,3
	out 061h,al
	mov al,0B6h
	out 043h,al
.skipAnOr:
	mov al,bl
	out 042h,al
	mov al,bh
	out 042h,al

	mov bx,[si + 2]
	mov dx,[sndCount]
	inc dx
	mov [sndCount],dx
	cmp bx,dx
	jnz .Bye

	add word [sndPtr],4
	mov word [sndCount],0
.Done:  jmp short .Bye
.noSound:
	call SndOff

.Bye:	popa
	ret

; -=( SndOff )=-------------------------------------------------------------
; -=( Schaltet den Speaker aus )=-
; --------------------------------------------------------------------------
SndOff:	push ax
	in al,061h
	and al,0fch
	out 061h,al
	pop ax
	ret