	bits 16

%define _TILE_ASM_
%include "defs.inc"

SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

global tileDraw
extern mapRefresh, mapData, tileTable, romFnt, fnt
	
; -=( tileDraw )=-----------------------------------------------------------
; -=( Zeichnet Tile XY an den zugehrigen Koordinaten )=-
; -=( IN: ? )=-
; --------------------------------------------------------------------------
align 2
tileDraw:
	pushx ax,bx,si

	lea si,[mapRefresh]             ;al = refreshFlag
	mov al,[si+bx]
	or al,al                        ;Refresh == 0?
	jz .Raus                        ;Tile nicht anzeigen
	dec al                          ;Sonst Refresh--
	mov [si+bx],al                  ;Zurckschreiben

	;Tile (Image) finden
	
	lea si,[mapData]
	mov bl,[si+bx]                  ;In Map indexen
	neg bl				;Solid wech
	js $-2
	
	xor	bh,bh
	
.TileOk	cmp bl,65			;Buchstabe?
	jge .IsChar

	shl bx,1                        ;bx *= 2
	mov si,[tileTable+bx]           ;In TileTable indexen (Tile finden)

	call PutImage                   ;Anzeigen!!!
	
.Raus:  popx si,bx,ax
	ret

.IsChar	cmp bl,97
	jb .Upper
	mov si,[tileTable+2*TILLETR]	;Background anzeigen
	jmp short .Lower
.Upper	mov si,[tileTable+2*TILULTR]	;Background
.Lower	call PutImage

	mov ax,[romFnt]
	mov [cs:FontPtr],ax
	mov ax,[romFnt+2]
	mov [cs:FontPtr+2],ax
	mov bh,[cs:Color]
	mov byte [cs:Color],120

	mov al,bl			;Buchstaben anzeigen
	add cx,2
	add dx,2
	call OutChar
	sub dx,2
	sub cx,10

	mov word [cs:FontPtr],fnt
	mov word [cs:FontPtr+2],seg fnt
	mov [cs:Color],bh

	popx si,bx,ax
	ret