	bits 16

%include "defs.inc"


GROUP DGROUP _BSS _DATA

extern SRand
extern Rand

extern isKey

global DoPyro

struc Pyro
	pyrX		resw 1
	pyrY		resw 1
endstruc

struc Spot
	sptX		resw 1
	sptY		resw 1
	sptDir		resw 1
	sptSpeed	resw 1
	sptColor	resb 1
	sptDummy	resb 1
endstruc

NUM_SPOTS	equ 70

SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

;;;;; sptInit ;;;;; IN: si = Pyro, di = Spot ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sptInit	push ax

	mov ax,[si+pyrX]		;Position vom Pyro kopieren
	mov [di+sptX],ax
	mov ax,[si+pyrY]
	mov [di+sptY],ax

	;Werte zufllig initialisieren
	call Rand
	and ax,63
	sub ax,32
	mov [di+sptDir],ax

	call Rand
	mov [di+sptColor],ah
	and ax,63
	add ax,140
	mov [di+sptSpeed],ax

	pop ax
	ret

;;;;; sptDraw ;;;;; IN: si = Pyro, di = Spot ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sptDraw	pusha

	mov cx,[di+sptX]		;Spot lschen
	shr cx,6
	mov dx,[di+sptY]
	shr dx,6
	xor al,al
	call SetPixel

	mov ax,[di+sptDir]		;Spot bewegen
	add [di+sptX],ax
	mov ax,[di+sptSpeed]
	sub [di+sptY],ax
	sub ax,5
	mov [di+sptSpeed],ax
;	dec byte [di+sptColor]

	mov ax,[di+sptY]
	cmp ax,[si+pyrY]
	jna .Alive
	call sptInit
.Alive:

	mov dx,ax			;Spot setzen
	shr dx,6
	mov cx,[di+sptX]
	shr cx,6
	mov al,[di+sptColor]
	call SetPixel

	popa
	ret


;;;;; DoPyro ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoPyro:	pusha

	mov bp,[cs:DrwVidSeg]
	mov ax,[cs:ShwVidSeg]
	mov [cs:DrwVidSeg],ax

	mov byte [cs:isKey],0

.InitPyro:
	mov si,thePyro
	mov di,Spots
	mov cx,NUM_SPOTS
.InitSpot:
	call sptInit
	add di,Spot_size
	dec cx
	jnz .InitSpot

.Pyro	cmp byte [cs:isKey],0
	jne .Done

	mov di,Spots
	mov cx,NUM_SPOTS
.DoSpot	call sptDraw
	add di,Spot_size
	dec cx
	jnz .DoSpot

	call VSync
	
	jmp short .Pyro

.Done	mov [cs:DrwVidSeg],bp
	popa
	ret

SEGMENT _DATA PUBLIC ALIGN=2 CLASS=DATA
thePyro	
istruc Pyro
	at pyrX, dw 64*154
	at pyrY, dw 64*160
iend

SEGMENT _BSS PUBLIC ALIGN=2 CLASS=BSS
Spots	resb Spot_size * NUM_SPOTS